# BaseStream<T, S extends BaseStream<T, S>> class abstract

Base interface for streams, which are sequences of elements supporting sequential and parallel aggregate operations.

This is the Dart equivalent of Java's BaseStream interface, adapted for Dart's language features and conventions.

## Example Usage

    // Basic stream operations
    final numbers = [1, 2, 3, 4, 5];
    final stream = DartStream.of(numbers);

    final result = stream
        .filter((n) => n > 2)
        .map((n) => n * 2)
        .toList();
    print(result); // [6, 8, 10]

See the documentation for `DartStream` and related classes for additional specification of streams, stream operations, and stream pipelines.

Implemented types
  - AutoCloseable
Annotations
  - @Generic(BaseStream)

## Constructors

BaseStream.new()
  Base interface for streams, which are sequences of elements supporting sequential and parallel aggregate operations.

## Properties

hashCode → int
  The hash code for this object.
  no setter inherited
runtimeType → Type
  A representation of the runtime type of the object.
  no setter inherited

## Methods

close() → void
  Closes this stream, causing all close handlers for this stream pipeline to be called.
  override
collect() → List<T>
  Returns a list containing the elements of this stream.
isParallel() → bool
  Returns whether this stream, if a terminal operation were to be executed, would execute in parallel.
iterable() → Iterable<T>
  Returns an iterable for the elements of this stream.
iterator() → Iterator<T>
  Returns an iterator for the elements of this stream.
noSuchMethod(Invocation invocation) → dynamic
  Invoked when a nonexistent method or property is accessed.
  inherited
onClose(void closeHandler()) → S
  Returns an equivalent stream with an additional close handler.
parallel() → S
  Returns an equivalent stream that is parallel.
sequential() → S
  Returns an equivalent stream that is sequential.
toString() → String
  A string representation of this object.
  inherited
unordered() → S
  Returns an equivalent stream that is unordered.

## Operators

operator ==(Object other) → bool
  The equality operator.
  inherited